const f = (s, t) => {
  const a = s[t];
  return a ? typeof a == "function" ? a() : Promise.resolve(a) : new Promise((i, n) => {
    (typeof queueMicrotask == "function" ? queueMicrotask : setTimeout)(n.bind(null, new Error("Unknown variable dynamic import: " + t)));
  });
}, b = {
  num: {
    type: "num",
    match: /(\.e?|\b)\d(e-|[\d.oxa-fA-F_])*(\.|\b)/g
  },
  str: {
    type: "str",
    match: /(["'])(\\[^]|(?!\1)[^\r\n\\])*\1?/g
  },
  strDouble: {
    type: "str",
    match: /"((?!")[^\r\n\\]|\\[^])*"?/g
  }
}, x = [
  [
    "bash",
    [/#!(\/usr)?\/bin\/bash/g, 500],
    [/\b(if|elif|then|fi|echo)\b|\$/g, 10]
  ],
  ["html", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^\s+<!DOCTYPE\s+html/g, 500]],
  ["http", [/^(GET|HEAD|POST|PUT|DELETE|PATCH|HTTP)\b/g, 500]],
  [
    "js",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require)\b/g,
      10
    ]
  ],
  [
    "ts",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require|implements|interface|namespace)\b/g,
      10
    ]
  ],
  ["py", [/\b(def|print|class|and|or|lambda)\b/g, 10]],
  ["sql", [/\b(SELECT|INSERT|FROM)\b/g, 50]],
  ["pl", [/#!(\/usr)?\/bin\/perl/g, 500], [/\b(use|print)\b|\$/g, 10]],
  ["lua", [/#!(\/usr)?\/bin\/lua/g, 500]],
  [
    "make",
    [/\b(ifneq|endif|if|elif|then|fi|echo|.PHONY|^[a-z]+ ?:$)\b|\$/gm, 10]
  ],
  ["uri", [/https?:|mailto:|tel:|ftp:/g, 30]],
  ["css", [/^(@import|@page|@media|(\.|#)[a-z]+)/gm, 20]],
  ["diff", [/^[+><-]/gm, 10], [/^@@ ?[-+,0-9 ]+ ?@@/gm, 25]],
  ["md", [/^(>|\t\*|\t\d+.)/gm, 10], [/\[.*\](.*)/g, 10]],
  ["docker", [/^(FROM|ENTRYPOINT|RUN)/gm, 500]],
  ["xml", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^<\?xml/g, 500]],
  ["c", [/#include\b|\bprintf\s+\(/g, 100]],
  ["rs", [/^\s+(use|fn|mut|match)\b/gm, 100]],
  ["go", [/\b(func|fmt|package)\b/g, 100]],
  ["java", [/^import\s+java/gm, 500]],
  ["asm", [/^(section|global main|extern|\t(call|mov|ret))/gm, 100]]
];
function v(s) {
  var n;
  return ((n = x.map(([l, ...e]) => {
    const o = e.reduce(
      (g, [m, r]) => {
        var u;
        return g + (((u = s.match(new RegExp(m, "g"))) == null ? void 0 : u.length) || 0) * r;
      },
      0
    );
    return [l, o];
  }).filter(([l, e]) => e >= 20).sort(
    ([l, e], [o, g]) => g - e
  )[0]) == null ? void 0 : n[0]) || "plain";
}
const d = {
  show_title: !0,
  hide_line_numbers: !1
}, p = {};
function y(s) {
  var t, a, i, n;
  return (n = (a = (t = s.replaceAll("&", "&#38;")).replaceAll) == null ? void 0 : (i = a.call(t, "<", "&lt;")).replaceAll) == null ? void 0 : n.call(i, ">", "&gt;");
}
function j(s, t) {
  return t ? `<span class="shjs-syn-${t}">${s}</span>` : s;
}
async function h(s, t, a) {
  try {
    let i;
    typeof t == "string" ? i = await (p[t] ?? (p[t] = await f(/* @__PURE__ */ Object.assign({ "./languages/asm.ts": () => import("./asm-379ba160.js"), "./languages/bash.ts": () => import("./bash-015e7dec.js"), "./languages/bf.ts": () => import("./bf-aa15c0c7.js"), "./languages/c.ts": () => import("./c-af18f50b.js"), "./languages/css.ts": () => import("./css-e64ee7ce.js"), "./languages/csv.ts": () => import("./csv-76a588d2.js"), "./languages/diff.ts": () => import("./diff-aec35e8c.js"), "./languages/docker.ts": () => import("./docker-5097d762.js"), "./languages/git.ts": () => import("./git-8f4b3dae.js"), "./languages/go.ts": () => import("./go-021f6b4b.js"), "./languages/html.ts": () => import("./html-9b836012.js"), "./languages/http.ts": () => import("./http-df1e3b03.js"), "./languages/ini.ts": () => import("./ini-5d10b777.js"), "./languages/java.ts": () => import("./java-243f4a1b.js"), "./languages/js.ts": () => import("./js-6df0c4c6.js"), "./languages/js_template_literals.ts": () => import("./js_template_literals-b38529ba.js"), "./languages/jsdoc.ts": () => import("./jsdoc-ae526b45.js"), "./languages/json.ts": () => import("./json-09f5a37f.js"), "./languages/leanpub-md.ts": () => import("./leanpub-md-bcd028d8.js"), "./languages/log.ts": () => import("./log-555045a2.js"), "./languages/lua.ts": () => import("./lua-caf2eaa5.js"), "./languages/make.ts": () => import("./make-8539a036.js"), "./languages/md.ts": () => import("./md-f2cc006f.js"), "./languages/pl.ts": () => import("./pl-0721bfcf.js"), "./languages/plain.ts": () => import("./plain-bca357dc.js"), "./languages/py.ts": () => import("./py-dab73c47.js"), "./languages/regex.ts": () => import("./regex-9ed70c94.js"), "./languages/rs.ts": () => import("./rs-6068a719.js"), "./languages/sql.ts": () => import("./sql-40e76724.js"), "./languages/todo.ts": () => import("./todo-844da562.js"), "./languages/toml.ts": () => import("./toml-2817dc06.js"), "./languages/ts.ts": () => import("./ts-25a1f69e.js"), "./languages/uri.ts": () => import("./uri-89a58c02.js"), "./languages/xml.ts": () => import("./xml-ea692477.js"), "./languages/yaml.ts": () => import("./yaml-1ed06a89.js") }), `./languages/${t}.ts`))) : i = t;
    const n = Array.from(
      typeof t == "string" ? i.default : t.sub
    );
    let l, e = {
      index: null,
      match: "",
      end: 0,
      part: {}
    };
    const o = [];
    let g = 0, m;
    for (; g < s.length; ) {
      e.index = null;
      for (let r = n.length; r-- > 0; ) {
        if (l = n[r].expand ? b[n[r].expand] : n[r], o[r] === void 0 || o[r].match.index < g) {
          if (l.match.lastIndex = g, m = l.match.exec(s), m === null) {
            n.splice(r, 1), o.splice(r, 1);
            continue;
          }
          o[r] = { match: m, lastIndex: l.match.lastIndex };
        }
        o[r].match[0] && (e.index === null || o[r].match.index <= e.index) && (e = {
          part: l,
          index: o[r].match.index,
          match: o[r].match[0],
          end: o[r].lastIndex
        });
      }
      if (e.index === null)
        break;
      a(s.slice(g, e.index), i.type), g = e.end, e.part.sub ? await h(
        e.match,
        typeof e.part.sub == "string" ? e.part.sub : typeof e.part.sub == "function" ? e.part.sub(e.match) : e.part,
        a
      ) : a(e.match, e.part.type);
    }
    a(s.slice(g, s.length), i.type);
  } catch (i) {
    console.error(i);
  }
}
function c(s, t) {
  return `<div class="shjs-lang-${t} shj-multiline" data-lang="${t}">${s}</div>`;
}
async function _(s, t, a = !0, i = d) {
  let n = "";
  return await h(
    s,
    t,
    (l, e) => n += j(y(l), e)
  ), c(
    a ? `<div><div class="shjs-numbers">${"<div></div>".repeat(
      i.hide_line_numbers ? 0 : s.split(`
`).length
    )}</div><div>${n}</div></div>` : n,
    t
  );
}
async function $(s, t = ((n) => (n = s.className.match(/shj-lang-([\w-]+)/)) == null ? void 0 : n[1])(), a, i = d) {
  let l = s.textContent;
  l !== null && (a ?? (a = `${s.tagName == "CODE" ? "in" : l.split(`
`).length < 2 ? "one" : "multi"}line`), s.dataset.lang = t, s.className = `${Array.from(s.classList).filter(
    (e) => !e.startsWith("shjs-") || e.startsWith("shjs-mode-")
  ).join(" ")}shjs-lang-${t} shjs-${a}`, i.show_title && s.classList.add("shjs-title"), s.innerHTML = await _(l, t, a === "multiline", i));
}
export {
  d as default_options,
  v as detect_language,
  $ as highlight_element,
  _ as highlight_text,
  p as languages,
  y as sanitize,
  j as to_span,
  h as tokenize
};
